import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Goods, GoodsParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品记录表
 */
export async function pageGoods(params: GoodsParam) {
  const res = await request.get<ApiResult<PageResult<Goods>>>(
    MODULES_API_URL + '/shop/goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品记录表列表
 */
export async function listGoods(params?: GoodsParam) {
  const res = await request.get<ApiResult<Goods[]>>(
    MODULES_API_URL + '/shop/goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品记录表
 */
export async function addGoods(data: Goods) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品记录表
 */
export async function updateGoods(data: Goods) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品记录表
 */
export async function removeGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品记录表
 */
export async function removeBatchGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品记录表
 */
export async function getGoods(id: number) {
  const res = await request.get<ApiResult<Goods>>(
    MODULES_API_URL + '/shop/goods/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
